package SQ.Columns.Databanks;

import SQ.Utils.StrategyParametersHelperV2;
import com.strategyquant.lib.L;
import com.strategyquant.tradinglib.*;
import com.strategyquant.tradinglib.optimization.WalkForwardMatrixResult;
import com.strategyquant.lib.ValuesMap;

public class StrategyParameters extends DatabankColumn {

	public StrategyParameters() {
		super(L.tsq("Strategy Parameters"), DatabankColumn.Text, ValueTypes.Maximize, 0, 0, 1);

		setWidth(200);
	}
	
	//------------------------------------------------------------------------

	@Override
	public double getNumericValue(ResultsGroup results, String resultKey, byte direction, byte plType, byte sampleType) throws Exception {
		return 0;
	}

	//------------------------------------------------------------------------
	
	@Override
	public String getValue(ResultsGroup results, String resultKey, byte direction, byte plType, byte sampleType) throws Exception {
		try {
			ValuesMap parameterTypes = new ValuesMap();
			parameterTypes.set(ParametrizationTypes.ParamTypePeriod, true);
			parameterTypes.set(ParametrizationTypes.ParamTypeShift, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeConstant, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeOtherParam, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeEntryLevel, true);
			parameterTypes.set(ParametrizationTypes.ParamTypeEntryLogic, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeExitUsed, true);
			parameterTypes.set(ParametrizationTypes.ParamTypeExitUnused, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeBoolean, false);
			parameterTypes.set(ParametrizationTypes.ParamTypeTradingOptions, false);

			boolean sameVariablesForLongShort = true;

			return StrategyParametersHelperV2.toString(StrategyParametersHelperV2.getParameterValues(results, parameterTypes, sameVariablesForLongShort));
		} catch(Exception e) {
			return "Error: " + e.getMessage();
		}
	}
}